fl

{
PropForth 5.5(DevKernel)

Gesture Sensor(APDS-9960)  
Using i2c_utility_0.4.f   
2015/10/23 12:36:41
 
   APDS-9960     Propeller
      scl   ----  P28   
      sda   ----  P29
       
      GND   ---- GND
      VDD   ---- 3.3V 
      LED   ---- 3.3V 
}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Slave addres[h39] for APDS-9960
h72 wconstant APDS-9960
d16 wconstant INTpin

\ APDS-9960 register addresses 
h80 wconstant APDS9960_ENABLE 
h81 wconstant APDS9960_ATIME 
h83 wconstant APDS9960_WTIME 
h84 wconstant APDS9960_AILTL 
h85 wconstant APDS9960_AILTH 
h86 wconstant APDS9960_AIHTL 
h87 wconstant APDS9960_AIHTH 
h89 wconstant APDS9960_PILT 
h8B wconstant APDS9960_PIHT 
h8C wconstant APDS9960_PERS 
h8D wconstant APDS9960_CONFIG1 
h8E wconstant APDS9960_PPULSE 
h8F wconstant APDS9960_CONTROL 
h90 wconstant APDS9960_CONFIG2 
h92 wconstant APDS9960_ID 
h93 wconstant APDS9960_STATUS 
h94 wconstant APDS9960_CDATAL 
h95 wconstant APDS9960_CDATAH 
h96 wconstant APDS9960_RDATAL 
h97 wconstant APDS9960_RDATAH 
h98 wconstant APDS9960_GDATAL 
h99 wconstant APDS9960_GDATAH 
h9A wconstant APDS9960_BDATAL 
h9B wconstant APDS9960_BDATAH 
h9C wconstant APDS9960_PDATA 
h9D wconstant APDS9960_POFFSET_UR 
h9E wconstant APDS9960_POFFSET_DL 
h9F wconstant APDS9960_CONFIG3 
hA0 wconstant APDS9960_GPENTH 
hA1 wconstant APDS9960_GEXTH 
hA2 wconstant APDS9960_GCONF1 
hA3 wconstant APDS9960_GCONF2 
hA4 wconstant APDS9960_GOFFSET_U 
hA5 wconstant APDS9960_GOFFSET_D 
hA7 wconstant APDS9960_GOFFSET_L 
hA9 wconstant APDS9960_GOFFSET_R 
hA6 wconstant APDS9960_GPULSE 
hAA wconstant APDS9960_GCONF3 
hAB wconstant APDS9960_GCONF4 
hAE wconstant APDS9960_GFLVL 
hAF wconstant APDS9960_GSTATUS 
hE4 wconstant APDS9960_IFORCE 
hE5 wconstant APDS9960_PICLEAR 
hE6 wconstant APDS9960_CICLEAR 
hE7 wconstant APDS9960_AICLEAR 
hFC wconstant APDS9960_GFIFO_U 
hFD wconstant APDS9960_GFIFO_D 
hFE wconstant APDS9960_GFIFO_L 
hFF wconstant APDS9960_GFIFO_R 

\ Bit fields 
1 wconstant APDS9960_PON 
2 wconstant APDS9960_AEN 
4 wconstant APDS9960_PEN
8 wconstant APDS9960_WEN 
d16 wconstant APSD9960_AIEN 
d32 wconstant APDS9960_PIEN 
d64 wconstant APDS9960_GEN 
1 wconstant APDS9960_GVALID 
1 wconstant APDS9960_GMODE

\ Acceptable parameters for setMode 
0 wconstant POWER 
1 wconstant AMBIENT_LIGHT 
2 wconstant PROXIMITY 
3 wconstant WAIT 
4 wconstant AMBIENT_LIGHT_INT 
5 wconstant PROXIMITY_INT 
6 wconstant GESTURE 
7 wconstant ALL 

\ LED Drive values 
0 wconstant LED_DRIVE_100mA 
1 wconstant LED_DRIVE_50mA 
2 wconstant LED_DRIVE_25mA 
3 wconstant LED_DRIVE_12.5mA 

\ Proximity Gain (PGAIN) values
0 wconstant PGAIN_1X 
1 wconstant PGAIN_2X 
2 wconstant PGAIN_4X 
3 wconstant PGAIN_8X 
\ ALS Gain (AGAIN) values
0 wconstant AGAIN_1X 
1 wconstant AGAIN_4X 
2 wconstant AGAIN_16X 
3 wconstant AGAIN_64X 

\ Gesture Gain (GGAIN) values */
0 wconstant GGAIN_1X
1 wconstant GGAIN_2X 
2 wconstant GGAIN_4X 
3 wconstant GGAIN_8X 

\ LED Boost values 
0 wconstant LED_BOOST_100 
1 wconstant LED_BOOST_150 
2 wconstant LED_BOOST_200 
3 wconstant LED_BOOST_300 

\ Gesture wait time values 
0 wconstant GWTIME_0ms 
1 wconstant GWTIME_2_8ms 
2 wconstant GWTIME_5_6ms 
3 wconstant GWTIME_8_4ms 
4 wconstant GWTIME_14_0ms 
5 wconstant GWTIME_22_4ms 
6 wconstant GWTIME_30_8ms 
7 wconstant GWTIME_39_2ms 

\ Default values
d219 wconstant ATIME               \ 103ms
d246 wconstant WTIME               \ 27ms
h87 wconstant PROX_PPULSE          \ 16us, 8 pulses
h89 wconstant GESTURE_PPULSE       \ 16us, 10 pulses
0 wconstant POFFSET_UR             \ 0 offset
0 wconstant POFFSET_DL             \ 0 offset
h60 wconstant CONFIG1              \ No 12x wait (WTIME) factor
LED_DRIVE_100mA wconstant LDRIVE 
PGAIN_4X wconstant PGAIN 
AGAIN_4X wconstant AGAIN 
0 wconstant PILT                   \ Low proximity threshold
d50 wconstant PIHT                 \ High proximity threshold
hFFFF wconstant AILT               \ Force interrupt for calibration
0 wconstant AIHT 
h11 wconstant PERS                 \ 2 consecutive prox or ALS for int.
1 wconstant CONFIG2                \ No saturation interrupts or LED boost
0 wconstant CONFIG3                \ Enable all photodiodes, no SAI
d40 wconstant GPENTH               \ Threshold for entering gesture mode
d30 wconstant GEXTH                \ Threshold for exiting gesture mode
h80 wconstant GCONF1               \ 8 dataset events for interrupt, 1st gesture for exit        <-2015.10.22
GGAIN_4X wconstant GGAIN 
LED_DRIVE_100mA wconstant GLDRIVE 
GWTIME_2_8ms wconstant GWTIME 
0 wconstant GOFFSET                \ No offset scaling for gesture mode
hC9 wconstant GPULSE               \ 32us, 10 pulses
0 wconstant GCONF3                 \ All photodiodes active during gesture
0 wconstant GIEN                   \ Disable gesture interrupts

d10 wconstant Gesture_Threshold
d50 wconstant Gesture_Sensivity1
d20 wconstant Gesture_Sensivity2


\ =========================================================================== 
\ Variables 
\ =========================================================================== 
variable FIFO d252 allot      \ FIFO buffer
wvariable interrupt
wvariable fifo_lvl            \ Gesture FIFO Level
variable u_first 4 allot      \ u_first,d_first,l_first,r_first
variable u_last 4 allot       \ u_last,d_last,l_last,r_last
wvariable procErr
variable ud_ratio_first
variable lr_ratio_first
variable ud_ratio_last
variable lr_ratio_last
variable ud_delta
variable lr_delta
\ variable gesture_ud_delta
\ variable gesture_lr_delta
variable ud_count
variable lr_count
variable gesture_ud_count
variable gesture_lr_count
variable decordErr
variable far_count
variable near_count
\ wvariable gestureDataIndex    \ Index of GestureData to save FIFO-buffer
wvariable gestureDataTotal    \ Total number of GestureData

\ =========================================================================== 
\ i2c
\ =========================================================================== 
: err_msg ." I2C error" ;
\ If error, print message
\ ( n1 -- )   n1:t/f
: err? if err_msg cr then ;

\ Start i2c-commnication 
\ This also can use SMBus device.
\ ( -- )
lockdict create _eestart forthentry
$C_a_lxasm w, h122  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z1[ixnW l, z1[ixnX l, z2WyP[U l, z20iPak l, z3ryPW0 l, z1bixnW l, z2WyP[V l, z20iPak l,
z3ryPW0 l, z1bixnX l, z1SV01X l, zl0 l, zCW l, zW0000 l, zG0000 l,
freedict

\ Re-defined RepeatedStart
\ ( -- )
: Sr _eestart ;

\ Stop i2c-commnication 
\ ( -- )
: _eestop
_scli                    \ Release scl 
_sdai                    \ Release sda
;

\ When SDA-line is stuck LOW, master should send nine clock-pulse.
\ ( -- )
: bus_clr d10 0 do _scll _sclo _scli loop ;

\ ------ Fast-mode(400kHz) i2c ------    

\ _eewrite ( c1 -- t/f ) write c1 to the eeprom, true if there was an error
\ Received acknowledge from i2c-device during scl is high
\ scl/sda use pull-up resistor at hi
\ clock:400kHz
lockdict create _eewrite forthentry
$C_a_lxasm w, h12C  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WyPW8 l, z1YVPQ0 l, z1rixnd l, z1Sy\C] l, z1[ixne l, z1Sy\C] l, z1bixne l, zfyPO1 l,
z3[yP[K l, z1[ixnd l, z1Sy\C] l, z1[ixne l, z1Sy\C] l, z1YF\Nl l, z1viPR6 l, z1bixne l,
z1Sy\C] l, z1bixnd l, z1SV01X l, z2WyPc7 l, z20iPik l, z3ryPb0 l, z1SV000 l, zW0000 l,
zG0000 l,
freedict

\ _eeread ( t/f -- c1 ) flag should be true is this is the last read
\ scl/sda use pull-up resistor at hi
\ clock:400kHz
lockdict create _eeread forthentry
$C_a_lxasm w, h12D  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WiPZB l, z2WyPO0 l, z1[ixne l, z2WyPj8 l, z1Sy\Ka l, z1[ixnf l, z1Sy\Ka l, z1XF\Vl l,
znyPO1 l, z1bixnf l, z3[yPnN l, z26VPW0 l, z1rixne l, z1Sy\Ka l, z1[ixnf l, z1Sy\Ka l,
z1bixnf l, z1bixne l, z1Sy\Ka l, z1SV01X l, z2WyPc9 l, z20iPik l, z3ryPb0 l, z1SV000 l,
zW0000 l, zG0000 l,
freedict

\ Write data to register in i2c_device
\ ( n1 n2 n3 -- t/f )  n1:data  n2:register  n3:slave_address  t/f:true if there was an error
: i2c_wr
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
_eewrite                      \ ( n1 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 t/f )
\ Write data   
swap _eewrite or              \ ( t/f )   
\ Stop I2C
_eestop                       
err?
;

\ Write series data to register in i2c_device
\ ( n1..nn n2 n3 n4 -- t/f )   n1..nn:data  n2:number  n3:register  n4:slave_address   t/f:true if there was an error
: i2c_wr_multi
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
_eewrite                                \ ( n1..nn n2 n3 t/f )
\ Write register                   
swap _eewrite or                        \ ( n1..nn n2 t/f )
swap                                    \ ( n1..nn t/f n2 )
\ Read n2 byte
dup 1 >
if                                      \ ( n1..nn t/f n2 )                 
     0 do                               \ ( n1..nn t/f )
          swap _eewrite or              \ ( n1.. nn t/f ) 
     loop
else                                    \ ( n1 t/f n2 )     
     drop swap _eewrite or              \ ( t/f )
then               
\ Stop I2C
_eestop 
err?
;

\ Read data from register in i2c_device
\ ( n1 n2 -- n3 t/f )  n1:register  n2:slave_address  n3:data  t/f:true if there was an error
: i2c_rd
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)   
tuck _eewrite                 \ ( n2 n1 t/f )
\ Write register
swap _eewrite or              \ ( n2 t/f )
swap                          \ ( t/f n2 )
\ Start read_process
Sr
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or _eewrite or              \ ( t/f )
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread             
\ Stop I2C
_eestop                                         
swap                         \ (n3 t/f )
err?                         \ ( n3 )
;

\ Read sereis data from series register in i2c_device
\ ( n1 n2 n3 -- n4 . . nn t/f )  n1:number  n2:register  n3:slave_address  n4..nn:series data  t/f:true if there was an error
: i2c_rd_multi
\ Start I2C 
_eestart
\ Write slave address[wr], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)  
tuck _eewrite                 \ ( n1 n3 n2 t/f )
\ Write register
swap _eewrite or              \ ( n1 n3 t/f )
swap                          \ ( n1 t/f n3 )
\ Repeated Start read_process
Sr
\ Write slave address[rd], then receive Acknowledge-bit(ACK:Lo  NACK:Hi)
1 or 
_eewrite or                   \ ( n1 t/f )
\ Read (n1-1)bytes
>r                            \ Push flag  ( n1 )
dup 1 > 
if 
     1 - 0 do 
          0 _eeread           \ ( n4..nn-1 )
     loop
else
     drop
then
\ Read 1byte ,then set sda to Hi(NACK:master->slave)
-1 _eeread                    \ ( n4..nn )
r>                            \ Pop flag   ( n4..nn t/f )
\ Stop I2C
_eestop      
err?                          \ ( n4..nn )         
;


\ =========================================================================== 
\ Main 
\ =========================================================================== 
\ ------- Debug -----------------------------------------------------------------------------------
\ Comment out to enter debug-mode
1 wconstant debug

\ Tab
\ ( -- )
: tab 9 emit ;
: 2tab tab tab ;

\ Print Up/Down/Left/Right
\ ( -- )
: prtUDLR
." U" tab ." D" tab ." L" tab ." R" cr
FIFO
gestureDataTotal W@ 0 do
     dup i 4* + dup           \ ( FIFOaddr FIFOaddr+[4xi] FIFOaddr+[4xi] ) 
     4 bounds do              \ ( FIFOaddr FIFOaddr+[4xi] )
          dup C@ . 1+ tab     \ ( FIFOaddr FIFOaddr+[4xi]+1 )
     loop                     
     drop cr                  \ ( FIFOaddr )
loop
drop     
; 

\ -------------------------------------------------------------------------------------------------


\ Read ID
\ ( -- )
: ID APDS9960_ID APDS-9960 i2c_rd ." ID:" hex . cr decimal ;

\ Set/clear bit on register
\ ( n1 n2 n3 -- )  n1:bit[h80/h40/h20/h10/8/4/2/1] n2:1[set] 0[clear] n3:register
: bitControl
dup >r                   \ ( n1 n2 n3 )
APDS-9960 i2c_rd         \ Read data from register  ( n1 n2 data )
rot2                     \ ( data n1 n2 )
if 
     or                  \ Set bit 
else 
     invert and          \ Clear bit 
then
r> APDS-9960 i2c_wr      \ Write data to register
;

\ Display FIFO data
\ ( -- )
: FIFO_data FIFO h7F dump ;

\ Write value to register
\ ( n1 n2 -- ) n1:value n2:register
: APDS_i2c_wr APDS-9960 i2c_wr ;

\ Read value from register
\ ( n1 -- ) n1:register
: APDS_i2c_rd APDS-9960 i2c_rd ;

\ Read 2byte data 
\ ( n1 -- n2 ) n1:register  n2:16bit data
: rd16bit 2 swap APDS-9960 i2c_rd_multi 8 lshift or ;

\ Set LED Drive
\ ( n1 -- ) n1:LED drive value
: setLED
3 and 6 lshift                               \ ( n1 ) n1=**00_0000
APDS9960_CONTROL APDS_i2c_rd                 \ Read CONTROL register
h3F and or                                   
APDS9960_CONTROL APDS_i2c_wr                 \ Write data to CONTROL register
;

\ Set Proximity Gain(PGAIN)
\ ( n1 -- ) n1:3/2/1/0
: setPGAIN
3 and 2 lshift                               \ ( n1 ) n1=0000_**00
APDS9960_CONTROL APDS_i2c_rd                 \ Read CONTROL register
hF3 and or
APDS9960_CONTROL APDS_i2c_wr                 \ Write data to CONTROL register
;

\ Set Ambient Light Gain(AGAIN)
\ ( n1 -- ) n1:3/2/1/0
: setAGAIN
3 and                                        \ ( n1 ) n1=0000_00**
APDS9960_CONTROL APDS_i2c_rd                 \ Read CONTROL register
hFC and or
APDS9960_CONTROL APDS_i2c_wr                 \ Write data to CONTROL register
;

\ Set ALS Interrupt Threshold 
\ ( n1 n2 -- ) n1:value[16bit] n2:AILT/AIHT register
: setALS_Int_Thresh
>r                                 \ Push register  ( n1 )
dup 8 rshift swap hFF and 2        \ ( H-byte L-byte 2 ) 
r>                                 \ Pop register  ( 2 L-byte H-byte register ) 
APDS-9960 i2c_wr_multi             \ Write 2byte to register
;

\ Set Gesture Gain(GGAIN)
\ ( n1 -- ) n1:3/2/1/0
: setGGAIN
3 and 5 lshift                               \ ( n1 ) n1=0**0_0000
APDS9960_GCONF2 APDS_i2c_rd                  \ Read GCONF2 register
h9F and or
APDS9960_GCONF2 APDS_i2c_wr                  \ Write data to GCONF2 register
;

\ Set Gesture LED Drive(GLDRIVE)
\ ( n1 -- ) n1:3/2/1/0
: setGLDRIVE
3 and 3 lshift                               \ ( n1 ) n1=000*_*000
APDS9960_GCONF2 APDS_i2c_rd                  \ Read GCONF2 register
hE7 and or
APDS9960_GCONF2 APDS_i2c_wr                  \ Write data to GCONF2 register
;

\ Set Gesture Wait Time(GWTIME)
\ ( n1 -- ) n1:7/6/5/4/3/2/1/0
: setGWTIME
7 and                                        \ ( n1 ) n1=0000_0***
APDS9960_GCONF2 APDS_i2c_rd                  \ Read GCONF2 register
hF8 and or
APDS9960_GCONF2 APDS_i2c_wr                  \ Write data to GCONF2 register
;

\ Set Gesture Inturupt Enable(GIEN)
\ ( n1 -- ) n1:1/0
: setGIEN
1 and 1 lshift                               \ ( n1 ) n1=0000_00*0
APDS9960_GCONF4 APDS_i2c_rd                  \ Read GCONF4 register
hFD and or
APDS9960_GCONF4 APDS_i2c_wr                  \ Write data to GCONF4 register
;


