fl                                                              
{
PropForth 5.5      

8x8DotMatrix when Simple Game
          
P0-P7 --- CharliePlexing 8x8DotMatrix 
3.3V ---- 3.3V
GND ----- GND

2015/10/23 16:09:54

}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
wvariable arrow -2 allot
h18 c, h3C c, h7E c, h18 c, h18 c, h18 c, h18 c, h18 c,     \ UP      
h18 c, h18 c, h18 c, h18 c, h18 c, h7E c, h3C c, h18 c,     \ DOWN
h00 c, h20 c, h60 c, hFF c, hFF c, h60 c, h20 c, h00 c,     \ RIGHT
h00 c, h04 c, h06 c, hFF c, hFF c, h06 c, h04 c, h00 c,     \ LEFT


\ =========================================================================== 
\ Variables 
\ =========================================================================== 
\ Buffer for 8x8 LED-Matrix
variable matrix 4 allot 

\ =========================================================================== 
\ Main 
\ =========================================================================== 

\ Drive 8x8-LED-Matrix curcuit for Charlieplexing by assembler-word
\ It takes about 16msec displaying 8-lines.
\ ( n1 -- )  n1:address of 8x8-Matrix buffer
lockdict create _matrix_Charlie_asm forthentry
$C_a_lxasm w, h12E  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WyPW8 l, z2WiPfg l, z2WiPmB l, z2Wyxj0 l, z2WyxW0 l, z1Sy\Ka l, z2WixZD l, z2Wyxmy l,
z2WiPve l, z20iPyk l, z3ryPr0 l, ziPuE l, z2[iQ3F l, z24yQ01 l, z2WixZG l, z1Sy\Ka l,
zfyPb1 l, z20yPj1 l, z3[yP[M l, z1SV04J l, z2WiPvf l, z20iPyk l, z3ryPr0 l, z1SV000 l,
z38 l, zJY0 l, z1 l,
freedict

              
\ Clear matrix buffer
\ ( -- )
: clr_matrix 0 matrix L! 0 matrix 4+ L! ;

\ Fill matrix-array by 1
\ ( -- )
: fill_matrix hFFFFFFFF matrix L! hFFFFFFFF matrix 4+ L! ;

{
clr_matrix
c" matrix _matrix_Charlie_asm" 0 cogx
}
\ Display 1char without moving
\ ( n1 -- )
: matrixArrow
8 u* arrow +
8 0 do
     dup
     C@ matrix i + C!
     1+
loop
drop
;

{
\ Driver for 8x8-Matrix-LED by Charlieplexing
\ Using P0 - P7
\ Top pin for drive is P0
\ $C_treg1:loop counter
\ $C_treg2:SCR drive data
\ $C_treg3:buffer address
\ ( n1 -- )  n1:address of 8x8-Matrix buffer 
fl
build_BootOpt :rasm
__1
     mov       $C_treg1 , # 8
     mov       $C_treg2 , __scr
     mov       $C_treg3 , $C_stTOS
     
__2     
     \ Set from P0 to P7 to Hi-Z (All LEDs off)
     mov       dira , # 0
     \ Set data to 0
     mov       outa , # 0
     \ Wait to drive next SCR
     jmpret  __delayret , # __delay
     
     \ each SCR on
     mov       outa , $C_treg2
     mov       dira , # hFF
     mov       $C_treg4 , __2.5usec
	add       $C_treg4 , cnt
     waitcnt   $C_treg4 , # 0                               
     
     \ Set data
     rdbyte    $C_treg4 , $C_treg3
     neg       $C_treg5 , $C_treg4
     sub       $C_treg5 , # 1
     mov       outa , $C_treg5
     
     \ Delay 1msec
     jmpret  __delayret , # __delay
     
     shl       $C_treg2 , # 1
     add       $C_treg3 , # 1
     
     djnz      $C_treg1 , # __2
     jmp       # __1

                                                                       
__delay
          mov       $C_treg4 , __1msec
		add       $C_treg4 , cnt
          waitcnt   $C_treg4 , # 0                               
__delayret

		ret
		
\ This value must be adjust when changing SCR     
__2.5usec
     d200      
__1msec
     d80000
     
__scr
     1     
;asm _matrix_Charlie_asm

}
